import '../cache.dart';

class Memoized1<V, A1> {
  final LruCache<A1, V> _cache;
  final V Function(A1) _body;

  Memoized1(V Function(A1) body, {int capacity = 128})
      : _body = body,
        _cache = LruCache(capacity: capacity);

  V call(A1 arg) {
    final cachedValue = _cache[arg];
    return cachedValue ?? (_cache[arg] = _body(arg));
  }

  void expire(A1 arg) => _cache.expire(arg);
  void expireAll() => _cache.expireAll();
}
